#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3300four4xi.py">
#<abstract4xi abstract = "fires to direction four and to distance 3300"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3300four4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

       
# -------------------------------------------------------------------------------------------------
# SHOT2FOUR - COORDINATE SIGNS OF SHOOT2FOUR4XI: (X + ,Y - ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2four33004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False
shot2four33004xi = {
                1:'1001x-3083y614z',
                2:'1033x-1216y2888z',
                3:'1034x-494y3094z',
                4:'1087x-451y3082z',
                5:'1097x-1805y2534z',
                6:'1115x-1181y2872z',
                7:'1138x-403y3070z',
                8:'1164x-3032y581z',
                9:'1187x-352y3058z',
                10:'1196x-1140y2855z',
                11:'1204x-1766y2513z',
                12:'1218x-2267y2064z',
                13:'1234x-296y3046z',
                14:'1276x-1095y2839z',
                15:'1277x-237y3033z',
                16:'1310x-1720y2492z',
                17:'1318x-174y3020z',
                18:'1323x-2972y549z',
                19:'1346x-2218y2038z',
                20:'1354x-1044y2822z',
                21:'1355x-107y3006z',
                22:'1389x-36y2992z',
                23:'1415x-1668y2470z',
                24:'1430x-987y2804z',
                25:'1471x-2161y2012z',
                26:'1479x-2904y516z',
                27:'1504x-926y2787z',
                28:'1517x-1610y2448z',
                29:'1574x-859y2769z',
                30:'1594x-2097y1986z',
                31:'1617x-1545y2426z',
                32:'1632x-2826y483z',
                33:'1642x-788y2751z',
                34:'167x-3203y775z',
                35:'1706x-711y2733z',
                36:'1714x-1474y2403z',
                37:'1715x-2026y1960z',
                38:'1767x-630y2714z',
                39:'1780x-2741y451z',
                40:'1807x-1397y2380z',
                41:'1823x-544y2695z',
                42:'1832x-1947y1933z',
                43:'1876x-454y2676z',
                44:'1897x-1314y2357z',
                45:'1923x-360y2657z',
                46:'1924x-2648y418z',
                47:'1945x-1862y1906z',
                48:'1965x-263y2637z',
                49:'196x-149y3290z',
                50:'1984x-1225y2334z',
                51:'2003x-162y2617z',
                52:'2035x-57y2597z',
                53:'2054x-1770y1879z',
                54:'2062x-2546y385z',
                55:'2065x-1131y2311z',
                56:'2143x-1031y2287z',
                57:'2159x-1672y1852z',
                58:'2195x-2438y353z',
                59:'2215x-926y2263z',
                60:'223x-632y3231z',
                61:'2259x-1567y1824z',
                62:'2281x-817y2239z',
                63:'230x-157y3288z',
                64:'2322x-2322y320z',
                65:'2342x-703y2215z',
                66:'2353x-1456y1797z',
                67:'2397x-584y2190z',
                68:'2442x-1339y1769z',
                69:'2443x-2199y287z',
                70:'2446x-462y2165z',
                71:'2488x-336y2140z',
                72:'2524x-1217y1741z',
                73:'2524x-207y2115z',
                74:'2552x-75y2090z',
                75:'2556x-2070y254z',
                76:'2600x-1090y1713z',
                77:'2663x-1935y221z',
                78:'266x-162y3285z',
                79:'268x-650y3224z',
                80:'2751x-987y1736z',
                81:'2763x-1794y188z',
                82:'2854x-1648y155z',
                83:'2938x-1497y122z',
                84:'3013x-1341y89z',
                85:'303x-164y3281z',
                86:'3080x-1182y56z',
                87:'3138x-1019y23z',
                88:'316x-664y3216z',
                89:'336x-3197y743z',
                90:'341x-162y3278z',
                91:'366x-674y3209z',
                92:'379x-156y3274z',
                93:'417x-682y3201z',
                94:'418x-147y3270z',
                95:'456x-134y3265z',
                96:'470x-685y3193z',
                97:'495x-117y3260z',
                98:'504x-3182y711z',
                99:'525x-685y3184z',
                100:'532x-97y3255z',
                101:'540x-1313y2978z',
                102:'569x-73y3249z',
                103:'581x-681y3176z',
                104:'604x-46y3243z',
                105:'621x-1309y2964z',
                106:'638x-15y3237z',
                107:'638x-672y3167z',
                108:'671x-3158y678z',
                109:'695x-660y3157z',
                110:'702x-1301y2949z',
                111:'752x-643y3147z',
                112:'785x-1288y2934z',
                113:'810x-622y3137z',
                114:'837x-3125y646z',
                115:'867x-596y3127z',
                116:'868x-1269y2919z',
                117:'880x-1864y2576z',
                118:'924x-567y3116z',
                119:'951x-1245y2904z',
                120:'980x-532y3105z',
                121:'989x-1838y2555z'}
#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3300four4xi" usage = "target function for charge33004xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3300four4xi(queue2four, consumer_channel2four, publisher_channel2four):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3300FOUR4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3300FOUR4XI -  QUEUE2FOUR: ", queue2four)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3300FOUR4XI -  CONSUMER_CHANNEL2FOUR: ", consumer_channel2four)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3300FOUR4XI -  PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3300FOUR4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2four.put(shot2four33004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3300FOUR4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3300FOUR4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3300FOUR4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2four8shot2four33004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2four8shot2four33004xi</nack2put4xi>" 
            
        publisher_channel2four.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3300FOUR4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3300FOUR4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FOUR: ", publisher_channel2four, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3300FOUR4XI - RETURNING QUEUE OBJECT QUEUE2FOUR: ", queue2four, " - TIME: ", time4xi())  
        # 
            
    return queue2four    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3300four4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                    